Ice Reference Documentation
<<< Previous | Proxies and Endpoints |

# Endpoints

## Synopsis

`endpoint` [ : `endpoint`...]

## Description

An endpoint list comprises one or more endpoints separated by a colon (`:`). An endpoint has the following format:

`protocol` [`option`...]

The supported protocols are `tcp`, `udp`, `ssl`, and `default`. If `default` is used, it is replaced by the value of the `Ice.Default.Protocol` property. If an endpoint is malformed, or an unknown protocol is specified, the application receives `Ice::EndpointParseException`.

| The `ssl` protocol is only available if the IceSSL plug-in is installed.

The protocols and their supported options are described in the sections that follow.

## TCP Endpoint

### Synopsis

tcp [-h `host`] [-p `port`] [-t `timeout`] [-z]

### Description

A `tcp` endpoint supports the following options:

Option | Description | Client Semantics | Server Semantics
--- | --- | --- | ---
-h `host` | Specifies the hostname or IP address of the endpoint. If not specified, the value of `Ice.Default.Host` is used instead. | Determines the hostname or IP address to which a connection attempt is made. | Determines the network interface on which the object adapter listens for connections, as well as the hostname that is advertised in proxies created by the adapter.
-p `port` | Specifies the port number of the endpoint. | Determines the port to which a connection attempt is made. (required) | The port will be selected by the operating system if this option is not specified or `port` is zero.
-t `timeout` | Specifies the endpoint timeout in milliseconds. | If `timeout` is greater than zero, it sets a maximum delay for binding and proxy invocations. If a timeout occurs, the application receives `Ice::TimeoutException`. | Determines the default timeout that is advertised in proxies created by the object adapter.
-z | Specifies bzip2 compression. | Determines whether compressed requests are sent. | Determines whether compression is advertised in proxies created by the adapter.

## UDP Endpoint

### Synopsis

udp [-v `major`.`minor`] [-e `major`.`minor`] [-h `host`] [-p `port`] [-c] [-z]

### Description

A `udp` endpoint supports the following options:

Option | Description | Client Semantics | Server Semantics
--- | --- | --- | ---
-v `major`.`minor` | Specifies the protocol major and highest minor version number to be used for this endpoint. If not specified, the protocol major version and highest supported minor version of the client-side Ice run time is used. | Determines the protocol major version and highest minor version used by the client side when sending messages to this endpoint. The protocol major version number must match the protocol major version number of the server; the protocol minor version number must not be higher than the highest minor version number supported by the server. | Determines the protocol major version and highest minor version advertised by the server side for this endpoint. The protocol major version number must match the protocol major version number of the server; the protocol minor version number must not be higher than the highest minor version number supported by the server.
-e `major`.`minor` | Specifies the encoding major and highest minor version number to be used for this endpoint. If not specified, the encoding major version and highest supported minor version of the client-side Ice run time is used. | Determines the encoding major version and highest minor version used by the client side when sending messages to this endpoint. The encoding major version number must match the encoding major version number of the server; the encoding minor version number must not be higher than the highest minor version number supported by the server. | Determines the encoding version and highest minor version advertised by the server side for this endpoint. The protocol major version number must match the protocol major version number of the server; the protocol minor version number must not be higher than the highest minor version number supported by the server.
-h `host` | Specifies the hostname or IP address of the endpoint. If not specified, the value of `Ice.Default.Host` is used instead. | Determines the hostname or IP address to which datagrams are sent. | Determines the network interface on which the object adapter listens for datagrams, as well as the hostname that is advertised in proxies created by the adapter.
-p `port` | Specifies the port number of the endpoint. | Determines the port to which datagrams are sent. (required) | The port will be selected by the operating system if this option is not specified or `port` is zero.
-c | Specifies that a connected UDP socket should be used. | None. | Causes the server to connect to the socket of the first peer that sends a datagram to this endpoint.
-z | Specifies bzip2 compression. | Determines whether compressed requests are sent. | Determines whether compression is advertised in proxies created by the adapter.

## SSL Endpoint

### Synopsis

ssl [-h `host`] [-p `port`] [-t `timeout`] [-z]

### Description

An `ssl` endpoint supports the following options:

Option | Description | Client Semantics | Server Semantics
--- | --- | --- | ---
-h `host` | Specifies the hostname or IP address of the endpoint. If not specified, the value of `Ice.Default.Host` is used instead. | Determines the hostname or IP address to which a connection attempt is made. | Determines the network interface on which the object adapter listens for connections, as well as the hostname that is advertised in proxies created by the adapter.
-p `port` | Specifies the port number of the endpoint. | Determines the port to which a connection attempt is made. (required) | The port will be selected by the operating system if this option is not specified or `port` is zero.
-t `timeout` | Specifies the endpoint timeout in milliseconds. | If `timeout` is greater than zero, it sets a maximum delay for binding and proxy invocations. If a timeout occurs, the application receives `Ice::TimeoutException`. | Determines the default timeout that is advertised in proxies created by the object adapter.
-z | Specifies bzip2 compression. | Determines whether compressed requests are sent. | Determines whether compression is advertised in proxies created by the adapter.

<<< Previous | Home |
Proxies and Endpoints | Up |